﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TuttyPOS.Forms.Class;

namespace TuttyPOS.Forms
{
    /// <summary>
    /// Interakční logika pro Groups.xaml
    /// </summary>
    public partial class Groups : Window
    {
        public Groups()
        {
            InitializeComponent();
        }
        readonly AddEditDelete addeditdelete = new AddEditDelete();
        readonly products_group groups = new products_group();
        int ID = 0;

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Loadgroups();            
        }

        private void Loadgroups()
        {
            TuttyPOS.TuttyPOSDataSet tuttyPOSDataSet = ((TuttyPOS.TuttyPOSDataSet)(this.FindResource("tuttyPOSDataSet")));
            // Načte data do tabulky products_group. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.products_groupTableAdapter tuttyPOSDataSetproducts_groupTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.products_groupTableAdapter();
            tuttyPOSDataSetproducts_groupTableAdapter.Fill(tuttyPOSDataSet.products_group);
            System.Windows.Data.CollectionViewSource products_groupViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("products_groupViewSource")));
            products_groupViewSource.View.MoveCurrentToFirst();
        }

        private void AddBTN_Click(object sender, RoutedEventArgs e)
        {
            groups.name = GroupsTXT.Text;
            addeditdelete.Add(groups);
            Loadgroups();
        }

        private void DeleteBTN_Click(object sender, RoutedEventArgs e)
        {
            groups.id_productsgroup = ID;
            addeditdelete.Delete(groups);
            Loadgroups();
        }

        private void Products_groupDataGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
                ID = Convert.ToInt32(addeditdelete.Selection(sender, "id_productsgroup"));
        }

        private void EditBTN_Click(object sender, RoutedEventArgs e)
        {
            groups.id_productsgroup = ID;
            groups.name = GroupsTXT.Text;
            addeditdelete.Edit(groups);
            MessageBox.Show(ID.ToString());
            Loadgroups();
        }
    }
}
