﻿using Npgsql;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TuttyPOS.Forms;

namespace TuttyPOS
{
    /// <summary>
    /// Interakční logika pro MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ExitBTN_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            var appVersion = Assembly.GetExecutingAssembly().GetName().Version;
            LabelVersion.Content = String.Format("Verze: {0}", appVersion);
            Thread thread = new Thread(NewThread);
            thread.Start();

        }

        private void NewThread()
    {
        using (TuttyPOSEntities DB = new TuttyPOSEntities())
        {
            DB.users.FirstOrDefault();
        }
            Thread.Sleep(2000);
        }

        private void PinButton_Click(object sender, RoutedEventArgs e)
        {
            PinKeypad pinKeypad = new PinKeypad();
            pinKeypad.ShowDialog();
        }

        private void LoginButton_Click(object sender, RoutedEventArgs e)
        {
            VirtualKeyboard virtualKeyboard = new VirtualKeyboard();
            virtualKeyboard.ShowDialog();
        }

        private void SettingsButton_Click(object sender, RoutedEventArgs e)
        {
            //using (NpgsqlConnection conn = new NpgsqlConnection("Server= localhost;Port=5432;Database=TuttyPOS;User Id=postgres;Password=123"))
            //{
            //    try
            //    {
            //        conn.Open();
            //        MessageBox.Show("OK");
            //    }
            //    catch
            //    {
            //        MessageBox.Show("Cant connect");
            //    }
            //}
            DBSetting dBSetting = new DBSetting();
            dBSetting.ShowDialog();
        }
    }
}
