﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TuttyPOS.Forms.Class;

namespace TuttyPOS.Forms
{
    /// <summary>
    /// Interakční logika pro Products.xaml
    /// </summary>
    public partial class Products : Window
    {
        public Products()
        {
            InitializeComponent();
        }
        readonly AddEditDelete addeditdelete = new AddEditDelete();
        readonly TuttyPOS.product product = new TuttyPOS.product();
        int ID = 0;

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            TuttyPOS.TuttyPOSDataSet tuttyPOSDataSet = ((TuttyPOS.TuttyPOSDataSet)(this.FindResource("tuttyPOSDataSet")));
            // Načte data do tabulky products. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.productsTableAdapter tuttyPOSDataSetproductsTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.productsTableAdapter();
            tuttyPOSDataSetproductsTableAdapter.Fill(tuttyPOSDataSet.products);
            System.Windows.Data.CollectionViewSource productsViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("productsViewSource")));
            productsViewSource.View.MoveCurrentToFirst();
            // Načte data do tabulky unit. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.unitTableAdapter tuttyPOSDataSetunitTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.unitTableAdapter();
            tuttyPOSDataSetunitTableAdapter.Fill(tuttyPOSDataSet.unit);
            System.Windows.Data.CollectionViewSource unitViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("unitViewSource")));
            unitViewSource.View.MoveCurrentToFirst();
            // Načte data do tabulky products_group. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.products_groupTableAdapter tuttyPOSDataSetproducts_groupTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.products_groupTableAdapter();
            tuttyPOSDataSetproducts_groupTableAdapter.Fill(tuttyPOSDataSet.products_group);
            System.Windows.Data.CollectionViewSource products_groupViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("products_groupViewSource")));
            products_groupViewSource.View.MoveCurrentToFirst();
            // Načte data do tabulky dph. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.dphTableAdapter tuttyPOSDataSetdphTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.dphTableAdapter();
            tuttyPOSDataSetdphTableAdapter.Fill(tuttyPOSDataSet.dph);
            System.Windows.Data.CollectionViewSource dphViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("dphViewSource")));
            dphViewSource.View.MoveCurrentToFirst();
        }
        private void Loadproducts()
        {
            TuttyPOS.TuttyPOSDataSet tuttyPOSDataSet = ((TuttyPOS.TuttyPOSDataSet)(this.FindResource("tuttyPOSDataSet")));
            // Načte data do tabulky products. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.productsTableAdapter tuttyPOSDataSetproductsTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.productsTableAdapter();
            tuttyPOSDataSetproductsTableAdapter.Fill(tuttyPOSDataSet.products);
            //System.Windows.Data.CollectionViewSource productsViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("productsViewSource")));
        }

        private void AddGroupBTN_Click(object sender, RoutedEventArgs e)
        {
            Groups groups = new Groups();
            groups.ShowDialog();
        }

        private void AddBTN_Click(object sender, RoutedEventArgs e)
        {
            product.name = NameTXT.Text;
            product.code = CodeTXT.Text;
            product.id_unit = Convert.ToInt32(UnitCombo.SelectedValue);
            product.value_w_vat = Math.Round(decimal.Parse(PriceWVAT.Text),2);
            product.value_n_vat = Math.Round(decimal.Parse(PriceNVAT.Text),2);
            product.id_dph = Convert.ToInt32(VATCombo.SelectedValue);
            product.id_productsgroup = Convert.ToInt32(GroupCombo.SelectedValue);
            product.text = TextTXT.Text;
            addeditdelete.Add(product);
            Loadproducts();
        }

        private void DeleteBTN_Click(object sender, RoutedEventArgs e)
        {
            product.id_products = ID;
            addeditdelete.Delete(product);
            Loadproducts();
        }

        private void ProductsDataGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ID = Convert.ToInt32(addeditdelete.Selection(sender, "id_products"));
        }

        private void PriceNVAT_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (txtfocus == 1)
            {
                TuttyPOSEntities DB = new TuttyPOSEntities();
                foreach (var dph in DB.dphs)
                    if (dph.id_dph == (int)VATCombo.SelectedValue)
                    {
                        try
                        {
                            decimal price = Math.Round((decimal)(Convert.ToDecimal(PriceNVAT.Text) + (Convert.ToDecimal(PriceNVAT.Text) * dph.value)), 2); ;
                            PriceWVAT.Text = price.ToString();
                        }
                        catch { }
                    }
            }
        }

        private void VATCombo_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
                TuttyPOSEntities DB = new TuttyPOSEntities();
                foreach (var dph in DB.dphs)
                    if (dph.id_dph == (int)VATCombo.SelectedValue)
                    {
                        try
                        {
                            PriceNVAT.Text = Math.Round((decimal)(Convert.ToDecimal(PriceWVAT.Text) - (Convert.ToDecimal(PriceWVAT.Text) * (dph.value * 100 / (100 + dph.value * 100)))), 2).ToString();
                        }
                        catch { }
                    }
        }

        private void PriceNVAT_PreviewTextInput(object sender, TextCompositionEventArgs e)
        {
            Regex regex = new Regex("[^0-9,]+");
            e.Handled = regex.IsMatch(e.Text);
        }

        private void PriceWVAT_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (txtfocus == 2)
            {
                TuttyPOSEntities DB = new TuttyPOSEntities();
                foreach (var dph in DB.dphs)
                    if (dph.id_dph == (int)VATCombo.SelectedValue)
                    {
                        try
                        {
                            decimal price = Math.Round((decimal)(Convert.ToDecimal(PriceWVAT.Text) - (Convert.ToDecimal(PriceWVAT.Text) * (dph.value * 100 / (100 + dph.value * 100)))), 2); ;
                            PriceNVAT.Text = price.ToString();
                        }
                        catch { }
                    }
            }
        }

        private void PriceWVAT_PreviewTextInput(object sender, TextCompositionEventArgs e)
        {
            Regex regex = new Regex("[^0-9,]+");
            e.Handled = regex.IsMatch(e.Text);
        }
        int txtfocus;
        private void PriceNVAT_GotFocus(object sender, RoutedEventArgs e)
        {
            txtfocus = 1;
        }

        private void PriceWVAT_GotFocus(object sender, RoutedEventArgs e)
        {
            txtfocus = 2;
        }
    }
}
