const LocalStrategy = require("passport-local").Strategy;
const { pool } = require("./dbConfig");
var crypto = require("crypto");


function initialize(passport) {
  console.log("Initialized");

  const authenticateUser = (email, password, done) => {
    console.log(email, password);
    pool.query(
      `SELECT * FROM users WHERE email = $1`, [email], (err, results) => {
        if (err) {
          throw err;
        }
        console.log(results.rows);

        if (results.rows.length > 0) {
          const user = results.rows[0];
          const hashpassword = crypto.createHash('sha256').update(password + "kje6rE1j3s", 'utf8').digest('hex');

          if (hashpassword == user.password) {
            return done(null, user);
          } else {
            //password is incorrect
            return done(null, false,{ message: "Špatné heslo" });
          }
        } else {
          // No user
          return done(null, false, { message: "Uživatel neexistuje" });
        }
      }
    );
  };

  passport.use(new LocalStrategy({ usernameField: "email", passwordField: "password" }, authenticateUser));

  passport.serializeUser((user, done) => done(null, user.id_user));

  passport.deserializeUser((id_user, done) => {
    pool.query(`SELECT * FROM users WHERE id_user = $1`, [id_user], (err, results) => {
      if (err) {
        return done(err);
      }
      return done(null, results.rows[0]);
    });
  });
}

module.exports = initialize;
