﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TuttyPOS.Forms.Class;

namespace TuttyPOS.Forms
{
    /// <summary>
    /// Interakční logika pro AddButtonProduct.xaml
    /// </summary>
    public partial class AddButtonProduct : Window
    {
        private readonly AddButton addButton;

        public AddButtonProduct(AddButton owner)
        {
            InitializeComponent();
            addButton = owner;
        }
        readonly AddEditDelete addeditdelete = new AddEditDelete();
        int ID = 0;

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            TuttyPOS.TuttyPOSDataSet tuttyPOSDataSet = ((TuttyPOS.TuttyPOSDataSet)(this.FindResource("tuttyPOSDataSet")));
            // Načte data do tabulky products. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.productsTableAdapter tuttyPOSDataSetproductsTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.productsTableAdapter();
            tuttyPOSDataSetproductsTableAdapter.Fill(tuttyPOSDataSet.products);
            System.Windows.Data.CollectionViewSource productsViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("productsViewSource")));
            productsViewSource.View.MoveCurrentToFirst();
        }

        private void AddBTN_Click(object sender, RoutedEventArgs e)
        {
            SelectProduct();
            this.Close();
        }

        private void ProductsDataGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ID = Convert.ToInt32(addeditdelete.Selection(sender, "id_products"));
        }

        private void Row_DoubleClick(object sender, MouseButtonEventArgs e)
        {
            SelectProduct();
            this.Close();
        }

        private void SelectProduct()
        {
            GlobalVariables.IdProduct = ID;
            TuttyPOSEntities DB = new TuttyPOSEntities();

            var products = from p in DB.products where p.id_products == ID select p;
            foreach (var product in products)
            {
                addButton.ProductTXT.Text = product.name;
            }
        }
    }
}
