﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TuttyPOS.Forms.Class;

namespace TuttyPOS.Forms
{
    /// <summary>
    /// Interakční logika pro ButtonsList.xaml
    /// </summary>
    public partial class ButtonsList : Window
    {
        public ButtonsList()
        {
            InitializeComponent();
        }
        readonly AddEditDelete addeditdelete = new AddEditDelete();
        readonly buttons_list buttonlist = new buttons_list();
        int ID = 0;

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Loadbuttonlist();            
        }

        private void Loadbuttonlist()
        {
            TuttyPOS.TuttyPOSDataSet tuttyPOSDataSet = ((TuttyPOS.TuttyPOSDataSet)(this.FindResource("tuttyPOSDataSet")));
            // Načte data do tabulky buttons_list. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.buttons_listTableAdapter tuttyPOSDataSetbuttons_listTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.buttons_listTableAdapter();
            tuttyPOSDataSetbuttons_listTableAdapter.Fill(tuttyPOSDataSet.buttons_list);
            // System.Windows.Data.CollectionViewSource buttons_listViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("buttons_listViewSource")));
        }

        private void AddBTN_Click(object sender, RoutedEventArgs e)
        {
            buttonlist.name = ButtonListTXT.Text;
            addeditdelete.Add(buttonlist);
            Loadbuttonlist();
        }

        private void EditBTN_Click(object sender, RoutedEventArgs e)
        {
            buttonlist.id_buttons_list = ID;
            buttonlist.name = ButtonListTXT.Text;
            addeditdelete.Edit(buttonlist);
            Loadbuttonlist();
        }

        private void Buttons_listDataGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ID = Convert.ToInt32(addeditdelete.Selection(sender, "id_buttons_list"));
            AddButtonFieldBTN.IsEnabled = true;
        }

        private void DeleteBTN_Click(object sender, RoutedEventArgs e)
        {
            buttonlist.id_buttons_list = ID;
            addeditdelete.Delete(buttonlist);
            Loadbuttonlist();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if(ID != 0)
            {
                GlobalVariables.IdButtonsList = ID;
                this.Close();
                ButtonsField buttonsfield = new ButtonsField();
                buttonsfield.ShowDialog();
            }
        }
    }
}
