﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace TuttyPOS.Forms
{
    /// <summary>
    /// Interakční logika pro PinKeypad.xaml
    /// </summary>
    public partial class POSAmount : Window, INotifyPropertyChanged
    {
        public POSAmount()
        {
            InitializeComponent();
            this.DataContext = this;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            switch (button.CommandParameter.ToString())
            {
                case "ESC":
                    this.DialogResult = false;
                    break;

                case "RETURN":
                    Class.POSItems.Amount = Convert.ToInt32(AmountTXT.Text);
                    this.DialogResult = true;
                    break;

                case "BACK":
                    if (AmountTXT.Text.Length > 0)
                    {
                        AmountTXT.Text = AmountTXT.Text.Substring(0, (AmountTXT.Text.Length - 1));
                    }
                    break;

                default:
                    AmountTXT.Text += button.Content.ToString();
                    break;
            }
        }

        #region INotifyPropertyChanged members

        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(String info)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(info));
        }

        #endregion



    }
}
