﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TuttyPOS.Forms.Class;

namespace TuttyPOS.Forms
{
    /// <summary>
    /// Interakční logika pro UserManager.xaml
    /// </summary>
    public partial class UserManager : Window
    {
        public UserManager()
        {
            InitializeComponent();
        }
        readonly AddEditDelete addeditdelete = new AddEditDelete();
        readonly user users = new user();
        int ID = 0;

        private void Loadusers()
        {
            TuttyPOS.TuttyPOSDataSet tuttyPOSDataSet = ((TuttyPOS.TuttyPOSDataSet)(this.FindResource("tuttyPOSDataSet")));
            // Načte data do tabulky users. Tento kód lze upravovat podle potřeby.
            TuttyPOS.TuttyPOSDataSetTableAdapters.usersTableAdapter tuttyPOSDataSetusersTableAdapter = new TuttyPOS.TuttyPOSDataSetTableAdapters.usersTableAdapter();
            tuttyPOSDataSetusersTableAdapter.Fill(tuttyPOSDataSet.users);
            // System.Windows.Data.CollectionViewSource usersViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("usersViewSource")));
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Loadusers();
        }

        private void AddBTN_Click(object sender, RoutedEventArgs e)
        {
            users.name = NameLabel.Text;
            users.login = LoginLabel.Text;
            users.password = Cryptography.Encrpyt(PasswordLabel.Password);
            users.pin = int.Parse(PINLabel.Password);
            addeditdelete.Add(users);
            Loadusers();
        }

        private void DeleteBTN_Click(object sender, RoutedEventArgs e)
        {
            users.id_user = ID;
            addeditdelete.Delete(users);
            Loadusers();
        }

        private void UsersDataGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ID = Convert.ToInt32(addeditdelete.Selection(sender, "id_user"));
        }

        private void EditBTN_Click(object sender, RoutedEventArgs e)
        {
            users.id_user = ID;
            users.name = NameLabel.Text;
            users.login = LoginLabel.Text;
            if(PasswordLabel.Password != "")
            {
                users.password = Cryptography.Encrpyt(PasswordLabel.Password);
            }
            if (PINLabel.Password != "")
            {
                users.pin = int.Parse(PINLabel.Password);
            }
            addeditdelete.Edit(users);
            Loadusers();
        }
    }
}
